Attribute VB_Name = "Globals"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' John Robbins
' Microsoft Systems Journal - August, 1997
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

' The name of the synchronization object that, when signaled, is used to
'  update the label.
Public Const SYNCHEVENT_UPDATELABEL As String = "ThreadTest_UpdateLabel"
' The name of the synchronization object that, when signaled, tells the
'  background thread to end.
Public Const SYNCHEVENT_ENDTHREAD As String = "ThreadTest_EndThread"


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public Declare Function CreateThread _
        Lib "kernel32" (ByVal lpThreadAttributes As Long, _
                        ByVal dwStackSize As Long, _
                        ByVal lpStartAddress As Any, _
                        ByRef lpParameter As Any, _
                        ByVal dwCreationFlags As Long, _
                        ByRef lpThreadId As Long) As Long

Public Declare Function TerminateThread _
        Lib "kernel32" (ByVal hThread As Long, _
                        ByVal dwExitCode As Long) As Long

Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Declare Function CreateEvent _
         Lib "kernel32" _
               Alias "CreateEventA" _
         (ByVal lpEventAttributes As Long, _
         ByVal bManualReset As Long, _
         ByVal bInitialState As Long, _
         ByVal lpName As String) As Long

Declare Function CloseHandle _
         Lib "kernel32" _
         (ByVal hObject As Long) As Long

Declare Function WaitForMultipleObjects _
         Lib "kernel32" (ByVal nCount As Long, _
                         ByRef lpHandles As Long, _
                         ByVal bWaitAll As Long, _
                         ByVal dwMilliseconds As Long) As Long

Declare Function WaitForSingleObject _
         Lib "kernel32" (ByVal hHandle As Long, _
                         ByVal dwMilliseconds As Long) As Long


Declare Function SetEvent _
         Lib "kernel32" (ByVal hEvent As Long) As Long


Declare Function ResetEvent _
         Lib "kernel32" (ByVal hEvent As Long) As Long

Public Const INFINITE = &HFFFF



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' This is the helper function that will create the appropriate events
'  for both the main thread and the background thread.
Sub CreateSynchEvents(ahEvents() As Long)

   ' The first event is the stop event so it is a manual reset event
   '  that is created NON-SIGNALED.
   ahEvents(0) = CreateEvent(0, 1, 0, SYNCHEVENT_ENDTHREAD)

#If DEBUGBUILD Then
      If (0 = ahEvents(0)) Then
         MsgBox ("CreateSynchEvents: ahEvents(0) = 0")
      End If
#End If

   ' The second event is the paused/running event.  It is created as a
   '  manual reset event that starts out as signaled.
   ahEvents(1) = CreateEvent(0, 1, 1, SYNCHEVENT_UPDATELABEL)

#If DEBUGBUILD Then
      If (0 = ahEvents(1)) Then
         MsgBox ("CreateSynchEvents: ahEvents(1) = 0")
      End If
#End If

End Sub

