// Circle.cpp : implementation file
//

#include "stdafx.h"
#include "Widget.h"
#include "WidgBase.h"
#include "Circle.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCircle

IMPLEMENT_SERIAL(CCircle, CWidget, 1)

CCircle::CCircle()
{
}

CCircle::CCircle (LPCRECT pRect)
{
    m_rect = *pRect;
}

CCircle::CCircle (int left, int top, int right, int bottom)
{
    m_rect.SetRect (left, top, right, bottom);
}

CCircle::~CCircle()
{
}

BEGIN_MESSAGE_MAP(CCircle, CWidget)
    //{{AFX_MSG_MAP(CCircle)
        // NOTE - the ClassWizard will add and remove mapping macros here.
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircle message handlers

void CCircle::Draw(CDC * pDC)
{
    CBrush brush (RGB (255, 255, 0)); // Yellow
    CBrush* pOldBrush = pDC->SelectObject (&brush);
    pDC->Ellipse (m_rect);
    pDC->SelectObject (pOldBrush);
}

void CCircle::DrawDragImage(CDC * pDC, POINT point)
{
    int nOldMode = pDC->SetROP2 (R2_NOT);
    CBrush* pOldBrush = (CBrush*) pDC->SelectStockObject (NULL_BRUSH);

    pDC->Ellipse (point.x, point.y,
        point.x + m_rect.Width (),
        point.y + m_rect.Height ());

    pDC->SelectObject (pOldBrush);
    pDC->SetROP2 (nOldMode);
}

BOOL CCircle::PtInWidget(POINT point)
{
    if (!m_rect.PtInRect (point))
        return FALSE;

    CPoint ptCenter;
    ptCenter.x = m_rect.left + (m_rect.Width () / 2);
    ptCenter.y = m_rect.top + (m_rect.Height () / 2);

    int cx = point.x - ptCenter.x;
    int cy = point.y - ptCenter.y;

    if ((cx * cx) + (cy * cy) <
        (m_rect.Width () / 2) * (m_rect.Width () / 2))
        return TRUE;

    return FALSE;
}

int CCircle::GetType()
{
    return 0; // Circle
}

void CCircle::Serialize (CArchive& ar)
{
    CWidget::Serialize (ar);

    if (ar.IsStoring ())
        ar << m_rect;
    else
        ar >> m_rect;
}
