// Square.cpp : implementation file
//

#include "stdafx.h"
#include "Widget.h"
#include "WidgBase.h"
#include "Square.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSquare

IMPLEMENT_SERIAL(CSquare, CWidget, 1)

CSquare::CSquare()
{
}

CSquare::CSquare (LPCRECT pRect)
{
    m_rect = *pRect;
}

CSquare::CSquare (int left, int top, int right, int bottom)
{
    m_rect.SetRect (left, top, right, bottom);
}

CSquare::~CSquare()
{
}

BEGIN_MESSAGE_MAP(CSquare, CWidget)
    //{{AFX_MSG_MAP(CSquare)
        // NOTE - the ClassWizard will add and remove mapping macros here.
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSquare message handlers

void CSquare::Draw(CDC * pDC)
{
    CBrush brush (RGB (255, 0, 0)); // Red
    CBrush* pOldBrush = pDC->SelectObject (&brush);
    pDC->Rectangle (m_rect);
    pDC->SelectObject (pOldBrush);
}

void CSquare::DrawDragImage(CDC * pDC, POINT point)
{
    int nOldMode = pDC->SetROP2 (R2_NOT);
    CBrush* pOldBrush = (CBrush*) pDC->SelectStockObject (NULL_BRUSH);

    pDC->Rectangle (point.x, point.y,
        point.x + m_rect.Width (),
        point.y + m_rect.Height ());

    pDC->SelectObject (pOldBrush);
    pDC->SetROP2 (nOldMode);
}

BOOL CSquare::PtInWidget(POINT point)
{
    return m_rect.PtInRect (point);
}

int CSquare::GetType()
{
    return 2; // Square
}

void CSquare::Serialize (CArchive& ar)
{
    CWidget::Serialize (ar);

    if (ar.IsStoring ())
        ar << m_rect;
    else
        ar >> m_rect;
}
